unit uCollection;

interface

uses
  Classes, uColletcionItems;

type
  TCarrinho = class(TCollection)
  private
    function GetItem(aIndex : integer) : TProduto;
  public
    property Item[Index : integer] : TProduto read GetItem;
    function Add : TProduto;
    function InsertProduto(aCodigo, aQtde : Integer; aPreco : Double; aDescricao : string) : TProduto;
    procedure Update(aCodigo, aQtde : Integer; aPreco : Double; aDescricao : string);
    function IndexOf(aCodigo : Integer) : Integer;
  end;

implementation

{ TCarrinho }

function TCarrinho.Add: TProduto;
begin
  Result := inherited Add as TProduto;
end;

function TCarrinho.GetItem(aIndex: integer): TProduto;
begin
  Result := inherited Items[aIndex] as TProduto;
end;

function TCarrinho.IndexOf(aCodigo: Integer): Integer;
var
  I : Integer;
begin
  Result := -1;

  for I := 0 to Self.Count - 1 do begin
    if (aCodigo = GetItem(I).Codigo) then begin
      Result := I;
      Break;
    end;
  end;
end;

function TCarrinho.InsertProduto(aCodigo, aQtde : Integer; aPreco : Double; aDescricao : string): TProduto;
begin
   Result := inherited Add as TProduto;
   Result.Codigo := aCodigo;
   Result.Preco := aPreco;
   Result.Descricao := aDescricao;
   Result.Qtde := aQtde;
end;

procedure TCarrinho.Update(aCodigo, aQtde : Integer; aPreco : Double; aDescricao : string);
var
  I : Integer;
begin
  for I := 0 to Self.Count - 1 do begin
    if (aCodigo = GetItem(I).Codigo) then begin
      GetItem(I).Codigo := aCodigo;
      GetItem(I).Descricao := aDescricao;
      GetItem(I).Preco := aPreco;
      GetItem(I).Qtde := aQtde;
      Break;
    end;
  end;
end;

end.
