unit FMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls, uGenerics;

type
  TfrmMain = class(TForm)
    GroupBox1: TGroupBox;
    lsvCarrinho: TListView;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    lstProdutos: TListView;
    btnCarrinho: TButton;
    btnRemover: TButton;
    btnAlterar: TButton;
    Bevel1: TBevel;
    Bevel2: TBevel;
    Bevel3: TBevel;
    Label4: TLabel;
    Edit1: TEdit;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    edtCodigo: TEdit;
    edtDescricao: TEdit;
    edtPreco: TEdit;
    edtQuantidade: TEdit;
    btnGravar: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure btnCarrinhoClick(Sender: TObject);
    procedure btnRemoverClick(Sender: TObject);
    procedure btnAlterarClick(Sender: TObject);
    procedure btnGravarClick(Sender: TObject);
  private
    oCarrinho : TCarrinho;

    procedure GerarLista;
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.dfm}

procedure TfrmMain.btnCarrinhoClick(Sender: TObject);
begin
  oCarrinho.Add(StrToInt(lstProdutos.Selected.Caption),
                StrToInt(lstProdutos.Selected.SubItems[2]),
                StrToFloat(lstProdutos.Selected.SubItems[1]),
                lstProdutos.Selected.SubItems[0]);

  Self.GerarLista;
end;

procedure TfrmMain.btnRemoverClick(Sender: TObject);
begin
  if lsvCarrinho.Items.Count <> 0 then begin
    oCarrinho.Delete(StrToInt(lsvCarrinho.Selected.Caption));
    Self.GerarLista;
  end;
end;

procedure TfrmMain.btnAlterarClick(Sender: TObject);
begin
  if lsvCarrinho.Items.Count <> 0 then begin
    edtCodigo.Text := lsvCarrinho.Selected.Caption;
    edtDescricao.Text := lsvCarrinho.Selected.SubItems[0];
    edtPreco.Text := lsvCarrinho.Selected.SubItems[1];
    edtQuantidade.Text := lsvCarrinho.Selected.SubItems[2];
  end;
end;

procedure TfrmMain.btnGravarClick(Sender: TObject);
begin
  oCarrinho.Update(StrToInt(edtCodigo.Text),
                StrToInt(edtQuantidade.Text),
                StrToFloat(edtPreco.Text),
                edtDescricao.Text);

  Self.GerarLista;
end;

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  oCarrinho := TCarrinho.Create;
end;

procedure TfrmMain.FormDestroy(Sender: TObject);
begin
  oCarrinho.Destroy;
end;

procedure TfrmMain.GerarLista;
var
 I : Integer;
 vNewItem : TListItem;
begin
  lsvCarrinho.Items.Clear;

  for I := 0 to oCarrinho.LstProdutos.Count - 1 do begin
    vNewItem := lsvCarrinho.Items.Add;
    vNewItem.Caption := IntToStr(oCarrinho.LstProdutos[I].Codigo);
    vNewItem.SubItems.Add(oCarrinho.LstProdutos[I].Descricao);
    vNewItem.SubItems.Add(FormatFloat('0.00', oCarrinho.LstProdutos[I].Preco));
    vNewItem.SubItems.Add(IntToStr(oCarrinho.LstProdutos[I].Qtde));
  end;
end;

end.
