unit UMenu;

interface

uses
  Windows, Messages, SysUtils, {Variants,} Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls,UCriticalSection,UMutex,USemaphore;

type
  TFrmMenu = class(TForm)
    gbxThreadProcess: TGroupBox;
    edtThreadProcess: TEdit;
    gbxThreadFile: TGroupBox;
    gbxThreadCriticalSection: TGroupBox;
    btnThreadCriticalSection01: TButton;
    gbxThreadMutex: TGroupBox;
    btnThreadMutex01: TButton;
    gbxThreadSemaphore: TGroupBox;
    btnThreadSemaphore01: TButton;
    lbxThreadFile: TListBox;
    procedure btnThreadCriticalSection01Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure btnThreadMutex01Click(Sender: TObject);
    procedure btnThreadSemaphore01Click(Sender: TObject);
  private
    { Private declarations }

  public
    { Public declarations }
    FCS:TRtlCriticalSection;
    FHMutex:THandle;
    FHSemaphore:THandle;
    FCountThreadTerminated:Integer;
    FTotalThread:integer;
    FFile:string;
    function GetFile:TStringList;
    procedure SaveFile(pSl: TStringList);
  end;

var
  FrmMenu: TFrmMenu;

implementation



{$R *.dfm}

procedure TFrmMenu.btnThreadCriticalSection01Click(Sender: TObject);
var xposition:integer;
begin
  lbxThreadFile.Items.Clear;
  DeleteFile(FFile);
  FCountThreadTerminated:=0;
  InitializeCriticalSection(FCS);
  for xposition:=1 to FTotalThread do begin
    TCriticalSection.Create(false);
  end;
end;

procedure TFrmMenu.btnThreadMutex01Click(Sender: TObject);
var xposition:integer;
begin
  lbxThreadFile.Items.Clear;
  DeleteFile(FFile);
  FCountThreadTerminated:=0;
  FHMutex:=CreateMutex(nil,false,nil);
  for xposition:=1 to FTotalThread do begin
    TMutex.Create(false);
  end;

end;


procedure TFrmMenu.btnThreadSemaphore01Click(Sender: TObject);
var xposition:integer;
begin
  lbxThreadFile.Items.Clear;
  DeleteFile(FFile);
  FCountThreadTerminated:=0;
  FHSemaphore:=CreateSemaphore(nil,1,1,nil);
  for xposition:=1 to FTotalThread do begin
    TSemaphore.Create(false);
  end;

end;

procedure TFrmMenu.FormShow(Sender: TObject);
begin
  FFile:='Thread.txt';
  FTotalThread:=10;
  FHSemaphore:=0;
  FHMutex:=0;
end;

function TFrmMenu.GetFile: TStringList;
begin
  result:=TStringList.Create;
  if FileExists(FFile) then
     result.LoadFromFile(FFile);
end;

procedure TFrmMenu.SaveFile(pSl: TStringList);
begin
  pSl.SaveToFile(FrmMenu.FFile);
end;





end.
