unit uFrmGerarMD5;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ShellApi;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
    function gerarMD5PrincipalExe: String;
    function gerarMD5ArquivoTexto : String;
  public
    { Public declarations }
    function ChamaAplicativo( Const Documento  : String;
                           Const Parametros : String  = '';
                           Const MostraErro : Boolean = True;
                           Const Invisivel  : Boolean = False;
                           Const Exclusivo  : Boolean = False ): Boolean;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
  Try
   ChamaAplicativo(ExtractFilePath(Application.ExeName)+'fsum1.bat','',True,True,True);
  Finally
    Edit1.Text := gerarMD5PrincipalExe;
    ChamaAplicativo(ExtractFilePath(Application.ExeName)+'fsum2.bat','',True,True,True);
    Edit2.Text := gerarMD5ArquivoTexto;
  End;
end;

function TForm1.gerarMD5ArquivoTexto: String;
var
  mMD5,Det : String;
 F : TextFile;
 lstMD5 : TStringList;
begin
    lstMD5 := TStringList.Create;

  //Deleta as 4 primeiras linhas do arquivo gerado, pois  gerado pelo FSum.
    lstMD5.LoadFromFile(ExtractFilePath(Application.ExeName)+'md5final.txt');
    lstMD5.Delete(0);
    lstMD5.Delete(0);
    lstMD5.Delete(0);
    lstMD5.Delete(0);
    lstMD5.SaveToFile(ExtractFilePath(Application.ExeName)+'md5final.txt');

    AssignFile(F,ExtractFilePath(Application.ExeName)+'md5final.txt');
    Reset(F);

    while not eof(F) do
    begin
      ReadLn(F,Det);
      if pos('md5loja.txt', Det) <> 0 then
      begin
        mMD5 := copy(Det,1,32);
      end;
    end;
    CloseFile(F);

    FreeAndNil(lstMD5);
    DeleteFile(ExtractFilePath(Application.ExeName)+'md5final.txt');
    DeleteFile(ExtractFilePath(Application.ExeName)+'md5loja.txt');

    Result := mMD5;
end;

function TForm1.gerarMD5PrincipalExe: String;
var
 mMD5Principal : string;
 Det : String;
 F : TextFile;
 lstMD5 : TStringList;
begin
    lstMD5 := TStringList.Create;

    //Deleta as 4 primeiras linhas do arquivo gerado, pois  gerado pelo FSum.
    lstMD5.LoadFromFile(ExtractFilePath(Application.ExeName)+'md5loja.txt');
    lstMD5.Delete(0);
    lstMD5.Delete(0);
    lstMD5.Delete(0);
    lstMD5.Delete(0);
    lstMD5.SaveToFile(ExtractFilePath(Application.ExeName)+'md5loja.txt');

    AssignFile(F,ExtractFilePath(Application.ExeName)+'md5loja.txt');
    Reset(F);

    while not eof(F) do
    begin
      ReadLn(F,Det);
      if pos(ExtractFileName(Application.ExeName), Det) <> 0 then
      begin
        Result := copy(Det,1,32);
      end;
    end;
    CloseFile(F);
end;

Function TForm1.ChamaAplicativo ( Const Documento  : String;
                           Const Parametros : String  = '';
                           Const MostraErro : Boolean = True;
                           Const Invisivel  : Boolean = False;
                           Const Exclusivo  : Boolean = False ): Boolean;
Var
   Erro, Tipo  : Integer;
   ErroStr     : String;
   ProcessInfo : TProcessInformation;
   StartUpInfo : TStartUpInfo;
   Executando  : Boolean;
   LinhaChamada : String;
begin
   If Invisivel
      Then Tipo := SW_Hide
      Else Tipo := SW_NORMAL;
   If Exclusivo
      Then Begin
              FillChar ( StartUpInfo, SizeOf ( StartUpInfo ), 0 );
              FillChar ( ProcessInfo, SizeOf ( ProcessInfo ), 0 );
              LinhaChamada := Documento;
              If Parametros <> ''
                 Then LinhaChamada := LinhaChamada + ' '+ Parametros;
              Executando := CreateProcess ( Nil, PChar ( LinhaChamada ),
                                            Nil, Nil,
                                            False, Normal_Priority_Class, Nil,
                                            Nil, StartUpInfo, ProcessInfo );
              If Executando
                 Then Begin
                         Erro := WaitForSingleObject ( ProcessInfo.hProcess, Infinite );
                         If Erro = WAIT_FAILED
                            Then Erro := GetLastError
                            Else Erro := 0
                      End
                 Else Erro := GetLastError
           End
      Else Erro := ShellExecute ( Application.Handle, 'open', PChar ( Documento ),
                                  PChar ( Parametros ), Nil, Tipo );
   Case Erro Of
      0                      : If Exclusivo
                                  Then ErroStr := ''
                                  Else ErroStr := 'Falta de memria ou recursos!';
      ERROR_FILE_NOT_FOUND   : ErroStr := 'Aplicativo no encontrado!';
      ERROR_PATH_NOT_FOUND   : ErroStr := 'Diretrio do aplicativo no encontrado!';
      ERROR_BAD_FORMAT       : ErroStr := 'Formato do aplicativo invlido!';
      SE_ERR_ACCESSDENIED    : ErroStr := 'Acesso negado a operao!';
      SE_ERR_ASSOCINCOMPLETE : ErroStr := 'Endereo invlido!';
      SE_ERR_DDEBUSY         : ErroStr := 'Recurso no disponvel no momento!';
      SE_ERR_DDEFAIL         : ErroStr := 'Falha na transao!';
      SE_ERR_DDETIMEOUT      : ErroStr := 'Tempo de espera esgotado!';
      SE_ERR_DLLNOTFOUND     : ErroStr := 'Biblioteca (DLL) no encontada!';
      SE_ERR_NOASSOC         : ErroStr := 'No existe nenhum aplicativo associado!';
      SE_ERR_OOM             : ErroStr := 'Falta de memria!';
      SE_ERR_SHARE           : ErroStr := 'Erro de compartilhamento!';
      Else ErroStr           := ''
   End;
   If MostraErro And ( ErroStr <> '' )
      Then  MessageDlg('No foi possvel executar "'+Documento+
                      '"'#13+ErroStr,mtError,[mbOK],0);
   Result := ErroStr = '';
end;

end.
