unit untPrincipal;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Grids, DBGrids, Mask, ExtCtrls, Buttons, ZConnection,
  DB, ZAbstractRODataset, ZAbstractDataset, ZDataset;

type
  TFrmAgenda = class(TForm)
    GroupBox2: TGroupBox;
    DBGridContatos: TDBGrid;
    Label1: TLabel;
    Nome: TLabel;
    edtCodigo: TEdit;
    edtNome: TEdit;
    Label3: TLabel;
    Label2: TLabel;
    Label4: TLabel;
    mskCadastro: TMaskEdit;
    mskTelefone: TMaskEdit;
    mskCelular: TMaskEdit;
    Panel1: TPanel;
    btnSalvar: TBitBtn;
    btnExcluir: TBitBtn;
    btnFechar: TBitBtn;
    btnNovo: TBitBtn;
    SQLiteConexao: TZConnection;
    ExecQuery: TZQuery;
    QueryView: TZQuery;
    dsAgenda: TDataSource;
    QueryViewID: TIntegerField;
    QueryViewNOME: TStringField;
    QueryViewTELEFONE: TStringField;
    QueryViewCELULAR: TStringField;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    edtEndereco: TEdit;
    edtComplemento: TEdit;
    edtBairro: TEdit;
    edtCidade: TEdit;
    cmbUF: TComboBox;
    mskCEP: TMaskEdit;
    QueryViewDT_CADASTRO: TDateField;
    QueryViewENDERECO: TStringField;
    QueryViewCOMPLEMENTO: TStringField;
    QueryViewBAIRRO: TStringField;
    QueryViewCIDADE: TStringField;
    QueryViewCEP: TStringField;
    QueryViewUF: TStringField;
    procedure btnFecharClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure btnNovoClick(Sender: TObject);
    procedure btnSalvarClick(Sender: TObject);
    procedure DBGridContatosCellClick(Column: TColumn);
    procedure btnExcluirClick(Sender: TObject);
  private
    novoRegistro: Boolean;
    
    procedure LimparTela;
    function ConnectionSQLite(cDatabase, cPath: String;
      cDeletar: boolean): Boolean;
    function Insert: Boolean;
    procedure Select(condicao, ordem: String);
    function Delete: Boolean;
    function ValidarDados: Boolean;
    procedure AtribuirDadosView;


    { Private declarations }
  public
    { Public declarations }
  end;

var
  FrmAgenda: TFrmAgenda;

implementation

{$R *.dfm}

procedure TFrmAgenda.btnFecharClick(Sender: TObject);
begin
  Close;
end;

procedure TFrmAgenda.LimparTela;
begin
  edtCodigo.Clear;
  mskCadastro.Text := DateToStr(date);
  edtNome.Clear;
  mskTelefone.Clear;
  mskCelular.Clear;
  edtEndereco.Clear;
  edtComplemento.Clear;
  edtBairro.Clear;
  edtCidade.Clear;
  mskCEP.Clear;
  cmbUF.ItemIndex := -1;
  edtNome.SetFocus;
end;

procedure TFrmAgenda.FormShow(Sender: TObject);
begin
  // conexao com o banco de dados SQLite
  if NOT ConnectionSQLite('ActiveDelphiAgenda.db3', 'C:\projeto_sqlite3', false) then
    ShowMessage('Problemas ao realizar conexo de dados.');

  Select('','');
  btnNovoClick(self);
  mskCadastro.Text := DateToStr(date);
end;

procedure TFrmAgenda.btnNovoClick(Sender: TObject);
begin
  LimparTela;
  novoRegistro := true;
end;

function TFrmAgenda.ConnectionSQLite(cDatabase: String; cPath: String; cDeletar: boolean): Boolean;
var
  fileLite : String;
begin
  result := false;
  fileLite := cPath +'\'+ cDatabase; 

  if cDeletar then
    //-- apagar arquivo da base de dados pre-existente
    // dirPath = v_PastaVendedor
    if FileExists(fileLite) then
      DeleteFile(fileLite);

  try
    with SQLiteConexao do begin
      Connected := false;
      Database  := fileLite;
      Connected := true;
    end;

    if SQLiteConexao.Connected then
      result := true;

  Except
    on E:Exception do ShowMessage(E.Message);
  end;
end;

function TFrmAgenda.Insert(): Boolean;
begin
  result := false;

  if novoRegistro then begin
    with ExecQuery do begin
      Close;
      SQL.Clear;
      SQL.Add(' begin; ');
      SQL.Add(' INSERT INTO agenda(NOME, DT_CADASTRO, TELEFONE, CELULAR, ENDERECO, COMPLEMENTO, BAIRRO, CIDADE, CEP, UF) VALUES( ');
      SQL.Add(' '''+ edtNome.Text +''',');
      SQL.Add(' '''+ StringReplace(FormatDateTime('yyyy/mm/dd', StrToDate(mskCadastro.Text)), '/', '-', [rfReplaceAll, rfIgnoreCase]) +''',');
      SQL.Add(' '''+ mskTelefone.Text +''',');
      SQL.Add(' '''+ mskCelular.Text +''',');
      SQL.Add(' '''+ edtEndereco.Text +''',');
      SQL.Add(' '''+ edtComplemento.Text +''',');
      SQL.Add(' '''+ edtBairro.Text +''',');
      SQL.Add(' '''+ edtCidade.Text +''',');
      SQL.Add(' '''+ mskCEP.Text +''',');
      SQL.Add(' '''+ cmbUF.Text +'''); ');
      SQL.Add(' commit; ');
      ExecSQL;
    end;
    result := true;
  end
  else begin
    with ExecQuery do begin
      Close;
      SQL.Clear;
      SQL.Add(' begin; ');
      SQL.Add(' UPDATE agenda SET ');
      SQL.Add(' NOME = '''+ edtNome.Text +''',');
      SQL.Add(' DT_CADASTRO = '''+ StringReplace(FormatDateTime('yyyy/mm/dd', StrToDate(mskCadastro.Text)), '/', '-', [rfReplaceAll, rfIgnoreCase]) +''',');
      SQL.Add(' TELEFONE = '''+ mskTelefone.Text +''',');
      SQL.Add(' CELULAR = '''+ mskCelular.Text +''',');
      SQL.Add(' ENDERECO = '''+ edtEndereco.Text +''',');
      SQL.Add(' COMPLEMENTO = '''+ edtComplemento.Text +''',');
      SQL.Add(' BAIRRO = '''+ edtBairro.Text +''',');
      SQL.Add(' CIDADE = '''+ edtCidade.Text +''',');
      SQL.Add(' CEP = '''+ mskCEP.Text +''',');
      SQL.Add(' UF = '''+ cmbUF.Text +''' ');
      SQL.Add(' WHERE ID = '+ edtCodigo.Text +';');
      SQL.Add(' commit; ');
      ExecSQL;
    end;
    result := true;
  end;
end;

procedure TFrmAgenda.Select(condicao, ordem: String);
begin
  with QueryView do begin
    Close;
    SQL.Clear;
    SQL.Add('SELECT * FROM AGENDA');

    if (Length(condicao) > 0) then
      SQL.Add(' WHERE ' + condicao);

    if (Length(ordem) > 0) then
      SQL.Add(' ORDER BY ' + ordem)
    else
      SQL.Add(' ORDER BY ID ASC');

    Open;
    First;
  end;
end;

function TFrmAgenda.Delete(): Boolean;
begin
  result := false;

  if edtCodigo.Text <> '' then begin

    if MessageBox(Application.Handle, 'Deseja realmente excluir os dados deste Contato?', 'Excluir Registro', MB_ICONQUESTION + MB_YESNO + MB_DEFBUTTON2) = ID_NO then
      Exit;

    with ExecQuery do begin
      Close;
      SQL.Clear;
      SQL.Add(' begin; ');
      SQL.Add(' DELETE FROM agenda WHERE id = '+ edtCodigo.Text +'; ');
      SQL.Add(' commit; ');
      ExecSQL;
    end;
    result := true;
  end
  else
    ShowMessage('ATENO: Nenhum registro selecionado a ser deletado!');
end;

procedure TFrmAgenda.btnSalvarClick(Sender: TObject);
begin
  try
    if ValidarDados then begin
      if Insert() then begin
        ShowMessage('Registro gravado/atualizado com sucesso!');
        LimparTela;
        Select('','');
      end
      else begin
        ShowMessage('Erro ao gravar registro.');
      end;
    end;
    
  Except
    on E:Exception do ShowMessage(E.Message);
  end;
end;

function TFrmAgenda.ValidarDados(): Boolean;
begin
  result := true;
  
  if Length(edtNome.Text) < 5 then begin
    ShowMessage('ATENO: Campo Nome Invlido!');
    result := false;
  end;
end;

procedure TFrmAgenda.AtribuirDadosView;
var
  i : integer;
begin
  edtCodigo.Text := dsAgenda.DataSet.FieldByName('ID').AsString;
  edtNome.Text := dsAgenda.DataSet.FieldByName('NOME').AsString;
  mskCadastro.Text := dsAgenda.DataSet.FieldByName('DT_CADASTRO').AsString;
  mskTelefone.Text := dsAgenda.DataSet.FieldByName('TELEFONE').AsString;
  mskCelular.Text := dsAgenda.DataSet.FieldByName('CELULAR').AsString;
  edtEndereco.Text := dsAgenda.DataSet.FieldByName('ENDERECO').AsString;
  edtComplemento.Text := dsAgenda.DataSet.FieldByName('COMPLEMENTO').AsString;
  edtBairro.Text := dsAgenda.DataSet.FieldByName('BAIRRO').AsString;
  edtCidade.Text := dsAgenda.DataSet.FieldByName('CIDADE').AsString;
  mskCEP.Text := dsAgenda.DataSet.FieldByName('CEP').AsString;

  for i:= 0 to 27 do begin
    if (cmbUF.Items.Strings[i] = dsAgenda.DataSet.FieldByName('UF').AsString)
        then cmbUF.ItemIndex:= i;
  end;

  novoRegistro := false;
end;

procedure TFrmAgenda.DBGridContatosCellClick(Column: TColumn);
begin
  AtribuirDadosView;
end;

procedure TFrmAgenda.btnExcluirClick(Sender: TObject);
begin
  try
    if Delete() then begin
      btnNovoClick(self);
      Select('','');
    end;

  Except
    on E:Exception do ShowMessage(E.Message);
  end;
end;

end.

